"use strict";

function _interopDefault(ex) {
  return ex && "object" == typeof ex && "default" in ex ? ex.default : ex;
}

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var _extends = _interopDefault(require("@babel/runtime/helpers/extends")), _defineProperty = _interopDefault(require("@babel/runtime/helpers/defineProperty")), _objectWithoutProperties = _interopDefault(require("@babel/runtime/helpers/objectWithoutProperties")), core = require("@westpac/core"), PropTypes = _interopDefault(require("prop-types"));

require("@babel/runtime/helpers/taggedTemplateLiteral");

var body = require("@westpac/body"), Well = function(_ref) {
  var tag = _ref.state.tag, rest = _objectWithoutProperties(_ref, [ "state" ]);
  return core.jsx(body.Body, _extends({
    tag: tag
  }, rest));
}, wellStyles = function() {
  var mq = core.useMediaQuery(), _useBrand = core.useBrand(), COLORS = _useBrand.COLORS, SPACING = _useBrand.SPACING;
  return mq({
    label: core.getLabel("well"),
    padding: [ SPACING(2), null, SPACING(4) ],
    marginBottom: SPACING(3),
    backgroundColor: COLORS.light,
    border: "1px solid ".concat(COLORS.border),
    borderRadius: "0.1875rem",
    "& > &": {
      backgroundColor: "#fff",
      margin: "".concat(SPACING(2), " 0")
    }
  })[0];
}, wellAttributes = function() {
  return null;
}, defaultWell = {
  component: Well,
  styles: wellStyles,
  attributes: wellAttributes
}, pkg = {
  name: "@westpac/well",
  version: "1.0.0",
  description: "Well component for the Westpac GEL Design System",
  repository: "https://github.com/WestpacGEL/GEL/tree/master/components/well",
  blender: {
    recipe: "blender/recipe.js"
  },
  components: [ {
    name: "Well",
    src: "Well.js"
  } ],
  author: "Westpac GEL Team <gel@westpac.com.au>",
  contributors: [ {
    name: "Dominik Wilkowski",
    email: "Hi@Dominik-Wilkowski.com",
    url: "https://dominik-wilkowski.com"
  }, {
    name: "Jonathan Stening",
    email: "info@jonathanstening.com",
    url: "http://jonathanstening.com"
  }, {
    name: "Jeremy Ortiz",
    email: "jeremy@jeremyortiz.io",
    url: "https://www.jeremyortiz.io/"
  }, {
    name: "Flore Laforge",
    email: "florelaforge@gmail.com",
    url: "http://florelaforge.com/"
  } ],
  license: "GPL-3.0+",
  scripts: {
    start: "PACKAGE_NAME=well webpack-dev-server --config ../../helpers/example/start.webpack.config.js",
    test: "exit 0 # start-server-and-test start http://localhost:8080 test:all",
    "test:dev": "start-server-and-test start http://localhost:8080 test:test-dev",
    "test:all": "yarn test:integration",
    "test:integration": "cypress run",
    "test:test-dev": "cypress open"
  },
  main: "dist/well.cjs.js",
  module: "dist/well.esm.js",
  dependencies: {
    "@babel/runtime": "^7.9.6",
    "@westpac/body": "^1.2.0",
    "@westpac/core": "^1.1.0",
    "prop-types": "^15.7.2"
  },
  peerDependencies: {
    react: "^16.13.1"
  },
  devDependencies: {
    cypress: "^4.5.0",
    react: "^16.13.1",
    "start-server-and-test": "^1.11.0"
  }
};

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach((function(key) {
      _defineProperty(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

var Well$1 = function(_ref) {
  var tag = _ref.tag, children = _ref.children, componentOverrides = _ref.overrides, rest = _objectWithoutProperties(_ref, [ "tag", "children", "overrides" ]), _useBrand = core.useBrand(), tokenOverrides = _useBrand.OVERRIDES[pkg.name], brandOverrides = _useBrand[pkg.name], defaultOverrides = {
    Well: defaultWell
  }, state = _objectSpread({
    tag: tag,
    overrides: componentOverrides
  }, rest), _overrideReconciler$W = core.overrideReconciler(defaultOverrides, tokenOverrides, brandOverrides, componentOverrides).Well, Well = _overrideReconciler$W.component, wellStyles = _overrideReconciler$W.styles, wellAttributes = _overrideReconciler$W.attributes;
  return core.jsx(Well, _extends({}, rest, {
    state: state
  }, wellAttributes(state), {
    css: wellStyles(state)
  }), children);
};

Well$1.propTypes = {
  tag: PropTypes.oneOfType([ PropTypes.func, PropTypes.string ]).isRequired,
  overrides: PropTypes.shape({
    Well: PropTypes.shape({
      styles: PropTypes.func,
      component: PropTypes.elementType,
      attributes: PropTypes.func
    })
  })
}, Well$1.defaultProps = {
  tag: "div"
}, exports.Well = Well$1;
